/* Julia Set in GLUT, gkf 3jan2K */ 
#include <stdlib.h>
#include <stdio.h>
#include <glut.h>
#include <math.h>
#define RND ((float)rand()/RAND_MAX)         /* random fraction */
#define SGN(x) ((x)<0?-1:1)                   /* signum function */
#define PIXEL 1000                               /* fat dots */
#define NAP  9                              /* microseconds */
#define SLEEP(u) usleep(u)
float redtop = 0., greentop = 0., bluetop = 1. ;        /* default colors */
float redbot = 0., greenbot = 0., bluebot = 1. ;
float time=0.;
int i=0;
/***********************************************************/
void dotsun(float xx){ 
  for(i=0;i<9999;i++)
  {
    glColor3f(1,1,0); 
    glBegin(GL_LINE_STRIP);
    glVertex2f(0,0+time);glVertex2f(sin(xx+i),cos(xx+i)+time); 
    glEnd();
  }
}
/***********************************************************/
void clearsun(float xx){
  for(i=0;i<9999;i++)
  {
    glColor3f(0.,0.,0.);
    glBegin(GL_LINE_STRIP);
    glVertex2f(0,0+time);glVertex2f(sin(xx+i),cos(xx+i)+time); 
    glEnd();
  } 
}
/***********************************************************/
void makesky(){
  glBegin(GL_TRIANGLE_STRIP);
  glColor3f(redtop,greentop,bluetop);
  glVertex2f(-2,2);glVertex2f(2,2);
  glColor3f(redbot,greenbot,bluebot);
  glVertex2f(-2,-2);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glColor3f(redtop,greentop,bluetop);
  glVertex2f(2,2);
  glColor3f(redbot,greenbot,bluebot);
  glVertex2f(-2,-2);glVertex2f(2,-2);
  glEnd();
}
/**********************************************************/
void wipeit(){
  glClear(GL_COLOR_BUFFER_BIT); glClearColor(0.,0.,0.,0.);  
}
/***********************************************************/
void display(){        
  for(i=0;i<10;i++)
  {
    makesky();
    dotsun(0);
    /*clearsun(0)*/;
    time=(time-.01);
    redtop=redtop+time/100;
    greentop=greentop+time/100;
    bluetop=bluetop+time/100;
    redbot=redbot+time/500;
    greenbot=greenbot+time/500;
    bluebot=bluebot+time/500;
  }
}
/***********************************************************/
void keyboard(unsigned char key, int x, int y){
  switch(key){ 
     case  27: fprintf(stderr," Thanks for using GLUT ! \n"); exit(0); break;
     case 'r': time=0; redtop=redbot=greentop=greenbot=0;bluetop=bluebot=1.; 
     case 'w': wipeit(); break;    
   }
}
/***********************************************************/
void idle(void){ glutPostRedisplay(); } 
/***********************************************************/
int main(int argc, char **argv){ 
  glutInitWindowSize(400, 400);  glutInitDisplayMode(GLUT_RGB); 
  glutCreateWindow("<< Julia Set in GLUT >>");
  glutDisplayFunc(display); glutKeyboardFunc(keyboard); glutIdleFunc(idle); 
  glMatrixMode(GL_PROJECTION); glLoadIdentity(); 
     glOrtho(-2.0,2.0,-2.0,2.0,-2.0,2.0);
  glMatrixMode(GL_MODELVIEW); glLoadIdentity();
  glutMainLoop();
  return 0; 
}

/* gkf 14jan2K */










